// rollup.config.js
import babel from 'rollup-plugin-babel';
import postcss from 'rollup-plugin-postcss';
export default {
    // 核心选项
    input: './src/components/index.js',
    output: {
        file: './src/lib/bundle.js',
        format: 'cjs',
    },
    plugins: [babel({
        exclude: 'node_modules/**' // 仅仅转译我们的源码
    }), postcss({
        extensions: ['.css'],
        extract: false, // 无论是 dev 还是其他环境这个配置项都不做 样式的抽离
        plugins: [
            require('autoprefixer')({ overrideBrowserslist: ['> 0.15% in CN'] }) // 自动添加css前缀
         ]
    }), ],
    external: ['react', 'styled-components','moment']
}