import React, {useEffect, useState, useRef} from 'react';

const moment = require('moment');
const Day = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"]


const DayPanel = (props) => {
  const {range, startYear, calendarData, rangeDate, onChange} = props
  const today = moment().format('YYYY-MM-DD');
  const initStart = rangeDate[0] || today
  const initEnd = rangeDate[1] || today

  const hourData = creatTimeData(24)
  // const minuteData = creatTimeData(60)

  const [pickerDay, setPickerDay] = useState(!range ? (moment(rangeDate).format('YYYY-MM-DD') || today) : '')
  const [selected, setSelected] = useState([rangeDate[0] || today, rangeDate[1] || today])
  const [startDay, setStartDay] = useState(range ? initStart : '')
  const [endDay, setEndDay] = useState(range ? initEnd : '')
  const [hoverDay, setHoverDay] = useState('')

  const [hour, setHour] = useState(range ? moment(rangeDate[0]).hours() : moment(rangeDate).hours())
  const [endHour, setEndHour] = useState(range ? moment(rangeDate[1]).hours() : moment(rangeDate).hours())
  // const [minute, setMinute] = useState(range?-1:moment(rangeDate).minute())

  let totalHeight = 0
  const [rootHeight, setRootHeight] = useState(totalHeight)

  const [scrollTop, setScrollTop] = useState(0)
  let activeMonthStr = ''
  const [activeMonth, setActiveMonth] = useState(activeMonthStr)

  const warpRef = useRef();
  const listRef = useRef();
  const startRef = useRef();

  useEffect(() => {
    const sortDate = [startDay, endDay].sort(dateSort)
    setSelected(sortDate)
    setHoverDay('')
    if (range) {
      let startStr = moment(`${startDay} ${hour}`, 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm')
      let endStr = moment(`${endDay} ${endHour}`, 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm')
      const sortDate = [startStr, endStr].sort(dateSort)
      onChange(sortDate)
    }
  }, [startDay, endDay])

  useEffect(() => {
    if (!range) {
      let dayStr = moment(`${pickerDay} ${hour}`, 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm')
      onChange(dayStr)
    } else {
      let startStr = moment(`${startDay} ${hour}`, 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm')
      let endStr = moment(`${endDay} ${endHour}`, 'YYYY-MM-DD HH').format('YYYY-MM-DD HH:mm')
      onChange([startStr, endStr])
    }
  }, [hour, endHour, pickerDay])

  useEffect(() => {
    setRootHeight(totalHeight)
    warpRef.current.scrollTop = startRef.current.parentNode.offsetTop + startRef.current.offsetTop
    warpRef.current.addEventListener('scroll', (val) => {
      setScrollTop(warpRef.current.scrollTop || 0)
    })
  }, [])


  useEffect(() => {
    setActiveMonth(activeMonthStr)
  }, [scrollTop])

  function handleClick(dayStr) {
    setHoverDay('')
    if (startDay && endDay) {
      setStartDay(dayStr)
      setHour(0)
      setEndDay('')
      setSelected([])
    }
    if (startDay && !endDay) {
      const sortDate = [startDay, dayStr].sort(dateSort)
      setSelected(sortDate)
      // setStartDay(sortDate[0])
      setEndDay(dayStr)
      setEndHour(0)
    }
  }

  // function handleTimeClick(num, type) {
  //   let isHour = type === 'Hour'
  //   isHour ? setHour(num) : setMinute(num)
  //   if (startDay && !endDay) { //选择了开始日期
  //     let date = moment(startDay).format('YYYY-MM-DD')
  //     let dayStr = moment(`${date} ${isHour ? num : hour}:${isHour ? minute : num}`).format('YYYY-MM-DD HH:mm')
  //     setStartDay(dayStr)
  //   }
  //   if (startDay && endDay) { //选择了结束日期
  //     let date = moment(endDay).format('YYYY-MM-DD')
  //     let dayStr = moment(`${date} ${isHour ? num : hour}:${isHour ? minute : num}`).format('YYYY-MM-DD HH:mm')
  //     setEndDay(dayStr)
  //   }
  // }

  // function handleOver(dayStr) {
  //   if (startDay && !endDay) {
  //     setHoverDay(dayStr)
  //     setSelected([startDay, dayStr].sort(dateSort))
  //   }
  // }

  function inputStart(val) {
    setStartDay(val)
    setSelected([val, endDay].sort(dateSort))
  }

  function inputEnd(val) {
    setEndDay(val)
    setSelected([val, startDay].sort(dateSort))
  }

  function setLast() {
    warpRef.current.scrollTop = rootHeight - warpRef.current.offsetHeight
  }

  return (<div className={'hourPicker'}>
    {range && <div className="inputWarp">
      <input
        className="inputItem date-input__start" placeholder="YYYY-MM-DD"
        maxLength="10"
        value={(startDay && moment(`${startDay} ${hour}`, 'YYYY-MM-DD HH').format('HH:mm,MMM DD,YYYY')) || ''}
        onChange={(e) => {
          inputStart(e.target.value)
        }}/>
      <span className={'dateDash'}> - </span>
      <input
        className="inputItem date-input__end" placeholder="YYYY-MM-DD"
        maxLength="10"
        value={(endDay && moment(`${endDay} ${endHour}`, 'YYYY-MM-DD HH').format('HH:mm,MMM DD,YYYY')) || ''}
        onChange={(e) => {
          inputEnd(e.target.value)
        }}/>
    </div>}
    <div className={'dayPicker'}>
      <div>
        <div className={'timePicker'}>
          <div className={'timeSelect'}>
            {hourData.map((i, index) => {
              return (<div
                key={i}
                className={`timeItem ${hour === index ? 'active' : ''}`}
                onClick={() => {
                  setHour(index)
                  // if(range){
                  //   if (hour === -1) return
                  //   handleTimeClick(index, 'Hour')
                  // }else {
                  //   setHour(index)
                  // }
                }}
              >{i}:00</div>)
            })}
          </div>

          {range && <div className={'timeSelect'}>
            {hourData.map((i, index) => {
              return (<div
                key={i}
                className={`timeItem ${endHour === index ? 'active' : ''}`}
                onClick={() => {
                  setEndHour(index)
                  // if(range){
                  //   setEndHour(index)
                  //   if (minute === -1) return
                  //   handleTimeClick(index, 'Minute')
                  // }else {
                  //   setEndHour(index)
                  // }
                }}
              >{i}:00</div>)
            })}
          </div>}
        </div>
      </div>
      <div className={'dayPanel hasMonthTitle'}>
        <div className={'monthTitle'}>{activeMonth}</div>
        <div className={'dayOfWeek'}>
          {Day.map(item => {
            return <div className={'dayOfWeekName'} key={item}>{item}</div>
          })}
        </div>
        <div className={'calendarWarp'} ref={warpRef}>
          <div className={'monthListRoot'}
               ref={listRef}
               style={{
                 height: `${totalHeight}px`,
               }}
          >
            {calendarData.length && calendarData.map((year) => {
              let height = 0
              return year.month.map(month => {
                height = (month.week.length - 1) * 40
                totalHeight += height
                if (month.offsetTop <= scrollTop && scrollTop < month.offsetTop + height) {
                  activeMonthStr = moment(`${year.year}-${month.month + 1}`).format('MMM YYYY')
                }
                return (<div
                  key={`${year.year}-${month.month}`}
                  className={'monthListItem'}
                  style={{
                    height: `${height}px`, top: `${month.offsetTop}px`,
                  }}
                >
                  {month.week.map(weekItem => {
                    let startEl = weekItem.days.some(i => moment(i.dayStr).isSame(range ? startDay : pickerDay, "day"))
                    return (<div
                      key={weekItem.weekNum}
                      className={'weekItem'}
                      ref={startEl ? startRef : null}
                    >
                      {weekItem.days.map(day => {
                        const afterToday = !moment().isAfter(day.dayStr)
                        const active = moment(day.dayStr).isSame(startDay, "day") || moment(day.dayStr).isSame(endDay, "day") || moment(day.dayStr).isSame(hoverDay, "day")
                        return (<div
                          key={`${year.year}-${month.month}-${day.day}`}
                          className={`dayItem
                                ${(!range && moment(day.dayStr).isSame(pickerDay, "day")) ? 'active' : ''}
                                ${active ? 'active' : ''}
                                ${afterToday ? 'disabled' : ''}
                                ${moment(day.dayStr).isBetween(selected[0], selected[1]) ? 'selectBetween' : ''}
                                `}
                          onClick={() => {
                            if (range) {
                              if (afterToday) return
                              handleClick(day.dayStr)
                            } else {
                              if (afterToday) return
                              setPickerDay(day.dayStr)
                            }
                          }}
                          onMouseOver={() => {
                            // if (afterToday) {
                            //   handleOver(today)
                            // } else {
                            //   handleOver(day.dayStr)
                            // }
                          }}
                        >
                          <div>{day.day}</div>
                        </div>)
                      })}
                    </div>)
                  })}
                </div>)
              })
            })}
          </div>
        </div>
      </div>
    </div>

  </div>)
}


// 侧边栏
function Sidebar(props) {
  const {setStartDay, setEndDay, clearActive, setLast} = props
  const [active, setActive] = useState('')
  useEffect(() => {
    clearActive && setActive('')
  }, [clearActive])
  const year = moment().year()
  const option = [{
    tabName: 'Last 7 Days', startDay: moment().subtract(6, 'days').format('YYYY-MM-DD'),
  }, {
    tabName: 'Last 30 Days', startDay: moment().subtract(29, 'days').format('YYYY-MM-DD'),
  }, {
    tabName: 'Last 90 Days', startDay: moment().subtract(89, 'days').format('YYYY-MM-DD'),
  }, {
    tabName: 'Last 180 Days', startDay: moment().subtract(179, 'days').format('YYYY-MM-DD'),
  }, {
    tabName: 'Last 365 Days', startDay: moment().subtract(364, 'days').format('YYYY-MM-DD'),
  }, {
    tabName: 'Year to Date', startDay: moment(`${year}-1-1`).format('YYYY-MM-DD'),
  }]
  return (<div>
    <div className={'sidebarWarp'}>
      {option.map(item => {
        return <div
          className={`sideItem
            ${active === item.tabName ? 'sideActive' : ''}
            `}
          key={item.tabName}
          onClick={() => {
            setLast()
            setActive(item.tabName)
            setStartDay(item.startDay)
            setEndDay(moment().format('YYYY-MM-DD'))
          }}
        >{item.tabName}</div>
      })}
    </div>
  </div>)
}


// 排序函数

function dateSort(a, b) {
  return Date.parse(a) - Date.parse(b);
}

function creatTimeData(number) {
  let data = []
  for (let i = 0; i < number; i++) {
    data.push(pad(i, 2))
  }

  function pad(num, n) {
    return (Array(n).join(0) + num).slice(-n);
  }

  return data
}

export default DayPanel;
